;EasyCodeName=Module1,1
.686 ; create 32 bit code
.Model flat, StdCall  ;32 bit memory model
Option CaseMap :none  ; case sensitive

;The MASM32 Runtime Library include file.
;<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
Include	\masm32\include\masm32rt.inc
;<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<

.Const
 Two = 2  ; assign number 2 to the word Two as a constant variable

.Code

start:
;<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
	Call Main
	inkey        ; pause the screen while waiting for user to press any key
	             ; to continue
    exit
;<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<

Main Proc Uses Ebx Esi  ; preserve registers Ebx and Esi
	Local Number:DWord
	Local numAmt:DWord
	Local toPower:DWord
	Local counter:DWord
	Local WantContinue:DWord
	; Number is the number being mulitipled
	; numAmt is the number of times 2 is multiplied by itself
	; toPower is just the numerical value for the power of 2
	; WantContinue is the sentinel value for while loop
    ;--------------------------------------------------------

    ; Eax, Ebx, Edx, and Esi are registers

   Mov WantContinue, 0   ; initialize WantContinue to zero

  .While ((WantContinue >= 0) && (WantContinue < -1))
  ; while WantContinue is greater than or equal to 0 And
  ; WantContinue is less than -1 do
  	print chr$(13, 10)  ; a carriage return line feed will be outputted to the
  	                    ; screen
    print chr$("A positive integer must be between 0 and 29 !", 13, 10)
    Mov numAmt, sval(input("Enter an integer for the powers of two : "))
    .If ((numAmt >= 0) && (numAmt <= 29))
       print chr$(13, 10)
      .If (numAmt == 0)         ; if numAmt is equal to 0
      	 print chr$(" ")        ; a space will be outputted to the screen
      	 print str$(Two)        ; 2 will be outputted to the screen
      	 print chr$("^")        ; ^ will be outputted to the screen
      	 print str$(numAmt)     ; 0 will be outputted to the screen
      	 print chr$(" = 1 ", 13, 10, 13, 10)
      .ElseIf (numAmt == 1)      ; if numAmt is equal to 1
      	 print chr$(" ")         ; a space will be outputted to the screen
      	 print str$(Two)         ; 2 will be outputted to the screen
      	 print chr$("^")         ; ^ will be outputted to the screen
      	 print str$(numAmt)      ; 1 will be outputted to the screen
      	 print chr$(" = ")
      	 print str$(Two)
      	 print chr$(13, 10, 13, 10)
      .ElseIf (numAmt >= 2)        ; if numAmt is greater than or equal to 2
         print chr$(" ")           ; a space will be outputted to the screen
         print str$(Two)           ; 2 will be outputted to the screen

         Mov Number, Two     ; set Number = 2
         Mov Ebx, Two        ; set Ebx = 2
         Mov Esi, 1          ; initialize Esi = 0 to begin while loop

         Mov Eax, numAmt     ; set Eax = numAmt
         Sub Eax, 1          ; Eax = Eax - 1
         Mov counter, Eax    ; set counter = Eax

	     .While Esi <= counter ;   while Esi is less than or equal to numAmt do
	       Mov Eax, Ebx            ; set Eax = Ebx
	       IMul Number             ; Eax = Eax * Number
	       Mov Ebx, Eax            ; set Ebx = Eax
	       print chr$(" x ")       ; * 2 will be outputted to the screen as many
	       print str$(Two)         ;  times according to while looop
	       Inc Esi                 ; Esi = Esi + 1
         .EndW
         Mov toPower, Esi          ; set toPower = Esi

         print chr$(" = ")         ; =  will be outputted to the screen
         print str$(Two)           ; 2 will be outputted to the screen
         print chr$("^")           ; ^ will be outputted to the screen
         print str$(toPower)
         print chr$(" = ")
         print str$(Ebx), 13, 10, 13, 10
      .EndIf
    .ElseIf
         print chr$(13, 10)
         print chr$(" You entered invalid integer!", 13, 10)
         print chr$(13, 10)
    .EndIf
    Mov WantContinue, sval(input("Enter -1 to quit program : "))
    Invoke ClearScreen ; clears the screen
  .EndW
    print chr$(13, 10)
    Ret
Main EndP

End start
